// =====================================================================
//  addframe.cl
// =====================================================================

//  Author:         (c) 2014 Camil Demetrescu
//  License:        See the end of this file for license information
//  Created:        June 9, 2014

//  Last changed:   $Date: 2014/06/09 15:00:07 $
//  Changed by:     $Author: demetres $
//  Revision:       $Revision: 1.00 $


#define IDX(x,y,w) ((y)*(w)+(x))

__kernel void addframe(__global unsigned char* in, 
                       __global unsigned char* out, 
                       int oh, int ow, 
                       int frame_size, unsigned char tone) {

    int x = get_global_id(0);
    int y = get_global_id(1);
    int w = ow - 2*frame_size;

    if (x >= ow || y >= oh) return;

    if (x < frame_size || x >= ow-frame_size || 
        y < frame_size || y >= oh-frame_size) 
         out[IDX(x,y,ow)] = tone;
    else out[IDX(x,y,ow)] = in[IDX(x-frame_size, y-frame_size, w)];
}


// Copyright (C) 2014 Camil Demetrescu

// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
// USA
